import "./style.css";
import { callEntry as b, useCanvas as E, useMaterial as B, useLayout as R, getMergeMeta as K, useHistory as L, useMessage as z, useCompile as W } from "@opentiny/tiny-engine-meta-register";
import { defineComponent as de, computed as q, ref as re, reactive as ie, resolveComponent as Z, createElementBlock as J, openBlock as $, unref as P, Fragment as se, renderList as ge, withDirectives as ue, normalizeClass as ee, createElementVNode as te, normalizeStyle as pe, createCommentVNode as ne, createBlock as oe, withModifiers as me, renderSlot as De, mergeProps as fe, vShow as he, provide as ve, onActivated as be, onDeactivated as ye, watch as xe, nextTick as Ce, onMounted as Me, onBeforeUnmount as Se, withCtx as le, createVNode as ae, toDisplayString as _e } from "vue";
import { PluginPanel as U } from "@opentiny/tiny-engine-common";
import { constants as G } from "@opentiny/tiny-engine-utils";
import { extend as F } from "@opentiny/vue-renderless/common/object";
const Q = {
  id: "engine.plugins.outlinetree",
  title: "大纲树",
  type: "plugins",
  icon: "plugin-icon-tree",
  widthResizable: !0
}, Ne = ["draggable", "onClick", "onMouseenter", "onDragstart", "onDragover", "onDragenter"], ke = {
  key: 0,
  class: "expand-icon"
}, we = /* @__PURE__ */ de({
  __name: "DraggableTree",
  props: {
    data: {
      type: Array,
      default: () => []
    },
    active: {
      type: String
    },
    actives: {
      type: Array,
      default: () => []
    },
    idKey: {
      type: String,
      default: "id"
    },
    labelKey: {
      type: String,
      default: "label"
    },
    childrenKey: {
      type: String,
      default: "children"
    },
    draggable: {
      type: Boolean,
      default: !1
    },
    disallowDrop: {
      type: Function,
      default: () => !1
    }
  },
  emits: ["click", "mouseenter", "drop"],
  setup(T, {
    emit: A
  }) {
    const t = T, i = q(() => t.actives.length === 0 && t.active ? [t.active] : t.actives), r = b((e) => {
      const {
        idKey: a,
        labelKey: u,
        childrenKey: k
      } = t, H = e[a], Y = e[u], V = e[k], I = {
        id: H,
        label: Y,
        rawData: e
      };
      return Array.isArray(V) && (I.children = V.map((X) => r(X))), I;
    }, {
      metaData: {
        id: "engine.plugins.outlinetree.DraggableTree.normalizeDataItem"
      },
      ctx: () => ({
        props: t,
        activesComputed: i,
        normalizeDataItem: r,
        normalizeData: D,
        normalizedData: s,
        useCollapseMap: p,
        collapseMap: y,
        setCollapse: l,
        switchCollapse: N,
        flattenNode: d,
        flattenNodes: g,
        rows: f,
        emit: m,
        handleClickRow: x,
        handleMouseEnterRow: C,
        useDraggingState: M,
        draggingState: o,
        resetDraggingState: w,
        handleDragStart: S,
        getPositionData: _,
        handleDragOver: h,
        handleDrop: c,
        handleDragEnd: v,
        handleDragLeaveContainer: n
      })
    }), D = b((e) => Array.isArray(e) ? e.map((a) => r(a)) : [], {
      metaData: {
        id: "engine.plugins.outlinetree.DraggableTree.normalizeData"
      },
      ctx: () => ({
        props: t,
        activesComputed: i,
        normalizeDataItem: r,
        normalizeData: D,
        normalizedData: s,
        useCollapseMap: p,
        collapseMap: y,
        setCollapse: l,
        switchCollapse: N,
        flattenNode: d,
        flattenNodes: g,
        rows: f,
        emit: m,
        handleClickRow: x,
        handleMouseEnterRow: C,
        useDraggingState: M,
        draggingState: o,
        resetDraggingState: w,
        handleDragStart: S,
        getPositionData: _,
        handleDragOver: h,
        handleDrop: c,
        handleDragEnd: v,
        handleDragLeaveContainer: n
      })
    }), s = q(() => D(t.data)), p = b(() => {
      const e = re({}), a = b((k, H) => {
        e.value[k] = H;
      }, {
        metaData: {
          id: "engine.plugins.outlinetree.DraggableTree.setCollapse"
        },
        ctx: () => ({
          collapseMap: e,
          setCollapse: a,
          switchCollapse: u,
          props: t,
          activesComputed: i,
          normalizeDataItem: r,
          normalizeData: D,
          normalizedData: s,
          useCollapseMap: p,
          flattenNode: d,
          flattenNodes: g,
          rows: f,
          emit: m,
          handleClickRow: x,
          handleMouseEnterRow: C,
          useDraggingState: M,
          draggingState: o,
          resetDraggingState: w,
          handleDragStart: S,
          getPositionData: _,
          handleDragOver: h,
          handleDrop: c,
          handleDragEnd: v,
          handleDragLeaveContainer: n
        })
      }), u = b((k) => {
        e.value[k] = !e.value[k];
      }, {
        metaData: {
          id: "engine.plugins.outlinetree.DraggableTree.switchCollapse"
        },
        ctx: () => ({
          collapseMap: e,
          setCollapse: a,
          switchCollapse: u,
          props: t,
          activesComputed: i,
          normalizeDataItem: r,
          normalizeData: D,
          normalizedData: s,
          useCollapseMap: p,
          flattenNode: d,
          flattenNodes: g,
          rows: f,
          emit: m,
          handleClickRow: x,
          handleMouseEnterRow: C,
          useDraggingState: M,
          draggingState: o,
          resetDraggingState: w,
          handleDragStart: S,
          getPositionData: _,
          handleDragOver: h,
          handleDrop: c,
          handleDragEnd: v,
          handleDragLeaveContainer: n
        })
      });
      return {
        collapseMap: e,
        setCollapse: a,
        switchCollapse: u
      };
    }, {
      metaData: {
        id: "engine.plugins.outlinetree.DraggableTree.useCollapseMap"
      },
      ctx: () => ({
        props: t,
        activesComputed: i,
        normalizeDataItem: r,
        normalizeData: D,
        normalizedData: s,
        useCollapseMap: p,
        flattenNode: d,
        flattenNodes: g,
        rows: f,
        emit: m,
        handleClickRow: x,
        handleMouseEnterRow: C,
        useDraggingState: M,
        draggingState: o,
        resetDraggingState: w,
        handleDragStart: S,
        getPositionData: _,
        handleDragOver: h,
        handleDrop: c,
        handleDragEnd: v,
        handleDragLeaveContainer: n
      })
    }), {
      collapseMap: y,
      setCollapse: l,
      switchCollapse: N
    } = p(), d = b((e, a, u = 0, k = !1) => {
      const {
        children: H,
        ...Y
      } = e, V = (H || []).map((X) => d(X, e.id, u + 1, k || y.value[e.id])).flat(), I = {
        ...Y,
        parentId: a,
        level: u,
        hasChildren: (H == null ? void 0 : H.length) > 0,
        collapsed: k
      };
      return V.forEach((X) => {
        X.parent || (X.parent = I);
      }), [I].concat(V);
    }, {
      metaData: {
        id: "engine.plugins.outlinetree.DraggableTree.flattenNode"
      },
      ctx: () => ({
        props: t,
        activesComputed: i,
        normalizeDataItem: r,
        normalizeData: D,
        normalizedData: s,
        useCollapseMap: p,
        collapseMap: y,
        setCollapse: l,
        switchCollapse: N,
        flattenNode: d,
        flattenNodes: g,
        rows: f,
        emit: m,
        handleClickRow: x,
        handleMouseEnterRow: C,
        useDraggingState: M,
        draggingState: o,
        resetDraggingState: w,
        handleDragStart: S,
        getPositionData: _,
        handleDragOver: h,
        handleDrop: c,
        handleDragEnd: v,
        handleDragLeaveContainer: n
      })
    }), g = b((e) => d({
      children: e
    }, null, -1).slice(1), {
      metaData: {
        id: "engine.plugins.outlinetree.DraggableTree.flattenNodes"
      },
      ctx: () => ({
        props: t,
        activesComputed: i,
        normalizeDataItem: r,
        normalizeData: D,
        normalizedData: s,
        useCollapseMap: p,
        collapseMap: y,
        setCollapse: l,
        switchCollapse: N,
        flattenNode: d,
        flattenNodes: g,
        rows: f,
        emit: m,
        handleClickRow: x,
        handleMouseEnterRow: C,
        useDraggingState: M,
        draggingState: o,
        resetDraggingState: w,
        handleDragStart: S,
        getPositionData: _,
        handleDragOver: h,
        handleDrop: c,
        handleDragEnd: v,
        handleDragLeaveContainer: n
      })
    }), f = q(() => g(s.value)), m = A, x = b((e, a) => {
      m("click", e, a);
    }, {
      metaData: {
        id: "engine.plugins.outlinetree.DraggableTree.handleClickRow"
      },
      ctx: () => ({
        props: t,
        activesComputed: i,
        normalizeDataItem: r,
        normalizeData: D,
        normalizedData: s,
        useCollapseMap: p,
        collapseMap: y,
        setCollapse: l,
        switchCollapse: N,
        flattenNode: d,
        flattenNodes: g,
        rows: f,
        emit: m,
        handleClickRow: x,
        handleMouseEnterRow: C,
        useDraggingState: M,
        draggingState: o,
        resetDraggingState: w,
        handleDragStart: S,
        getPositionData: _,
        handleDragOver: h,
        handleDrop: c,
        handleDragEnd: v,
        handleDragLeaveContainer: n
      })
    }), C = b((e) => {
      m("mouseenter", e);
    }, {
      metaData: {
        id: "engine.plugins.outlinetree.DraggableTree.handleMouseEnterRow"
      },
      ctx: () => ({
        props: t,
        activesComputed: i,
        normalizeDataItem: r,
        normalizeData: D,
        normalizedData: s,
        useCollapseMap: p,
        collapseMap: y,
        setCollapse: l,
        switchCollapse: N,
        flattenNode: d,
        flattenNodes: g,
        rows: f,
        emit: m,
        handleClickRow: x,
        handleMouseEnterRow: C,
        useDraggingState: M,
        draggingState: o,
        resetDraggingState: w,
        handleDragStart: S,
        getPositionData: _,
        handleDragOver: h,
        handleDrop: c,
        handleDragEnd: v,
        handleDragLeaveContainer: n
      })
    }), M = b(() => {
      const e = {
        dragged: null,
        hovering: null,
        position: "",
        borderClass: "",
        forbidInsert: !1
      }, a = ie({
        ...e
      }), u = b(() => {
        Object.assign(a, e);
      }, {
        metaData: {
          id: "engine.plugins.outlinetree.DraggableTree.resetDraggingState"
        },
        ctx: () => ({
          initialState: e,
          draggingState: a,
          resetDraggingState: u,
          props: t,
          activesComputed: i,
          normalizeDataItem: r,
          normalizeData: D,
          normalizedData: s,
          useCollapseMap: p,
          collapseMap: y,
          setCollapse: l,
          switchCollapse: N,
          flattenNode: d,
          flattenNodes: g,
          rows: f,
          emit: m,
          handleClickRow: x,
          handleMouseEnterRow: C,
          useDraggingState: M,
          handleDragStart: S,
          getPositionData: _,
          handleDragOver: h,
          handleDrop: c,
          handleDragEnd: v,
          handleDragLeaveContainer: n
        })
      });
      return {
        draggingState: a,
        resetDraggingState: u
      };
    }, {
      metaData: {
        id: "engine.plugins.outlinetree.DraggableTree.useDraggingState"
      },
      ctx: () => ({
        props: t,
        activesComputed: i,
        normalizeDataItem: r,
        normalizeData: D,
        normalizedData: s,
        useCollapseMap: p,
        collapseMap: y,
        setCollapse: l,
        switchCollapse: N,
        flattenNode: d,
        flattenNodes: g,
        rows: f,
        emit: m,
        handleClickRow: x,
        handleMouseEnterRow: C,
        useDraggingState: M,
        handleDragStart: S,
        getPositionData: _,
        handleDragOver: h,
        handleDrop: c,
        handleDragEnd: v,
        handleDragLeaveContainer: n
      })
    }), {
      draggingState: o,
      resetDraggingState: w
    } = M(), S = b((e, a) => {
      t.draggable && (e.dataTransfer.setDragImage(new Image(), 0, 0), o.dragged = a, a.hasChildren && l(a.id, !0));
    }, {
      metaData: {
        id: "engine.plugins.outlinetree.DraggableTree.handleDragStart"
      },
      ctx: () => ({
        props: t,
        activesComputed: i,
        normalizeDataItem: r,
        normalizeData: D,
        normalizedData: s,
        useCollapseMap: p,
        collapseMap: y,
        setCollapse: l,
        switchCollapse: N,
        flattenNode: d,
        flattenNodes: g,
        rows: f,
        emit: m,
        handleClickRow: x,
        handleMouseEnterRow: C,
        useDraggingState: M,
        draggingState: o,
        resetDraggingState: w,
        handleDragStart: S,
        getPositionData: _,
        handleDragOver: h,
        handleDrop: c,
        handleDragEnd: v,
        handleDragLeaveContainer: n
      })
    }), _ = b((e) => {
      const a = e.currentTarget.getBoundingClientRect(), u = e.clientY - a.top, k = 8;
      return u <= k ? {
        position: "top",
        borderClass: "border-top"
      } : u >= a.height - k ? {
        position: "bottom",
        borderClass: "border-bottom"
      } : {
        position: "center",
        borderClass: "border-all"
      };
    }, {
      metaData: {
        id: "engine.plugins.outlinetree.DraggableTree.getPositionData"
      },
      ctx: () => ({
        props: t,
        activesComputed: i,
        normalizeDataItem: r,
        normalizeData: D,
        normalizedData: s,
        useCollapseMap: p,
        collapseMap: y,
        setCollapse: l,
        switchCollapse: N,
        flattenNode: d,
        flattenNodes: g,
        rows: f,
        emit: m,
        handleClickRow: x,
        handleMouseEnterRow: C,
        useDraggingState: M,
        draggingState: o,
        resetDraggingState: w,
        handleDragStart: S,
        getPositionData: _,
        handleDragOver: h,
        handleDrop: c,
        handleDragEnd: v,
        handleDragLeaveContainer: n
      })
    }), h = b((e, a) => {
      if (!t.draggable)
        return;
      const u = _(e);
      if (a.id === f.value[0].id && u.position !== "center") {
        e.preventDefault();
        return;
      }
      if (t.disallowDrop({
        dragged: o.dragged,
        target: a,
        position: u.position
      })) {
        Object.assign(o, {
          ...u,
          hovering: a,
          forbidInsert: !0
        });
        return;
      }
      e.preventDefault(), Object.assign(o, {
        ...u,
        hovering: a,
        forbidInsert: !1
      });
    }, {
      metaData: {
        id: "engine.plugins.outlinetree.DraggableTree.handleDragOver"
      },
      ctx: () => ({
        props: t,
        activesComputed: i,
        normalizeDataItem: r,
        normalizeData: D,
        normalizedData: s,
        useCollapseMap: p,
        collapseMap: y,
        setCollapse: l,
        switchCollapse: N,
        flattenNode: d,
        flattenNodes: g,
        rows: f,
        emit: m,
        handleClickRow: x,
        handleMouseEnterRow: C,
        useDraggingState: M,
        draggingState: o,
        resetDraggingState: w,
        handleDragStart: S,
        getPositionData: _,
        handleDragOver: h,
        handleDrop: c,
        handleDragEnd: v,
        handleDragLeaveContainer: n
      })
    }), c = b(() => {
      if (!t.draggable || o.forbidInsert)
        return;
      const {
        dragged: e,
        hovering: a,
        position: u
      } = o;
      m("drop", {
        dragged: e,
        target: a,
        position: u
      });
    }, {
      metaData: {
        id: "engine.plugins.outlinetree.DraggableTree.handleDrop"
      },
      ctx: () => ({
        props: t,
        activesComputed: i,
        normalizeDataItem: r,
        normalizeData: D,
        normalizedData: s,
        useCollapseMap: p,
        collapseMap: y,
        setCollapse: l,
        switchCollapse: N,
        flattenNode: d,
        flattenNodes: g,
        rows: f,
        emit: m,
        handleClickRow: x,
        handleMouseEnterRow: C,
        useDraggingState: M,
        draggingState: o,
        resetDraggingState: w,
        handleDragStart: S,
        getPositionData: _,
        handleDragOver: h,
        handleDrop: c,
        handleDragEnd: v,
        handleDragLeaveContainer: n
      })
    }), v = b(() => {
      w();
    }, {
      metaData: {
        id: "engine.plugins.outlinetree.DraggableTree.handleDragEnd"
      },
      ctx: () => ({
        props: t,
        activesComputed: i,
        normalizeDataItem: r,
        normalizeData: D,
        normalizedData: s,
        useCollapseMap: p,
        collapseMap: y,
        setCollapse: l,
        switchCollapse: N,
        flattenNode: d,
        flattenNodes: g,
        rows: f,
        emit: m,
        handleClickRow: x,
        handleMouseEnterRow: C,
        useDraggingState: M,
        draggingState: o,
        resetDraggingState: w,
        handleDragStart: S,
        getPositionData: _,
        handleDragOver: h,
        handleDrop: c,
        handleDragEnd: v,
        handleDragLeaveContainer: n
      })
    }), n = b((e) => {
      if (!t.draggable)
        return;
      const a = e.currentTarget.getBoundingClientRect(), u = 4;
      (e.clientX <= a.left + u || e.clientX >= a.right - u || e.clientY <= a.top + u || e.clientY >= a.bottom - u) && Object.assign(o, {
        hovering: null
      });
    }, {
      metaData: {
        id: "engine.plugins.outlinetree.DraggableTree.handleDragLeaveContainer"
      },
      ctx: () => ({
        props: t,
        activesComputed: i,
        normalizeDataItem: r,
        normalizeData: D,
        normalizedData: s,
        useCollapseMap: p,
        collapseMap: y,
        setCollapse: l,
        switchCollapse: N,
        flattenNode: d,
        flattenNodes: g,
        rows: f,
        emit: m,
        handleClickRow: x,
        handleMouseEnterRow: C,
        useDraggingState: M,
        draggingState: o,
        resetDraggingState: w,
        handleDragStart: S,
        getPositionData: _,
        handleDragOver: h,
        handleDrop: c,
        handleDragEnd: v,
        handleDragLeaveContainer: n
      })
    });
    return (e, a) => {
      const u = Z("svg-icon");
      return $(), J("div", {
        class: "draggable-tree",
        onDragleave: a[2] || (a[2] = //@ts-ignore
        (...k) => P(n) && P(n)(...k))
      }, [($(!0), J(se, null, ge(f.value, (k) => {
        var H, Y, V;
        return ue(($(), J("div", {
          key: k.id,
          class: ee(["tree-row", "flex-center", {
            active: i.value.includes(k.id),
            dragging: ((H = P(o).hovering) == null ? void 0 : H.id) === k.id,
            "border-all": ((Y = P(o).hovering) == null ? void 0 : Y.id) === k.id && P(o).position === "center",
            forbid: P(o).forbidInsert
          }]),
          draggable: T.draggable ? "true" : void 0,
          onClick: (I) => P(x)(I, k),
          onMouseenter: (I) => P(C)(k),
          onDragstart: (I) => P(S)(I, k),
          onDragover: (I) => P(h)(I, k),
          onDragenter: (I) => P(h)(I, k),
          onDrop: a[0] || (a[0] = //@ts-ignore
          (...I) => P(c) && P(c)(...I)),
          onDragend: a[1] || (a[1] = //@ts-ignore
          (...I) => P(v) && P(v)(...I))
        }, [te("div", {
          class: "content flex-center",
          style: pe({
            paddingLeft: `${12 * k.level}px`
          })
        }, [k.hasChildren ? ne("", !0) : ($(), J("span", ke)), k.hasChildren ? ($(), oe(u, {
          key: 1,
          name: "dropdown",
          class: ee(["expand-icon", {
            rotate: P(y)[k.id]
          }]),
          onClick: me((I) => P(N)(k.id), ["stop"])
        }, null, 8, ["class", "onClick"])) : ne("", !0), te("div", {
          class: ee(["slot-content", "flex-center", {
            [P(o).borderClass]: ((V = P(o).hovering) == null ? void 0 : V.id) === k.id && P(o).position !== "center",
            forbid: P(o).forbidInsert
          }])
        }, [De(e.$slots, "content", fe({
          ref_for: !0
        }, k), void 0, !0)], 2)], 4)], 42, Ne)), [[he, !k.collapsed]]);
      }), 128))], 32);
    };
  }
}), ce = (T, A) => {
  const t = T.__vccOpts || T;
  for (const [i, r] of A)
    t[i] = r;
  return t;
}, j = /* @__PURE__ */ ce(we, [["__scopeId", "data-v-4265bea0"]]), {
  PAGE_STATUS: O
} = G, Te = {
  components: {
    PluginPanel: U,
    DraggableTree: j
  },
  props: {
    fixedPanels: {
      type: Array
    }
  },
  emits: ["close", "fix-panel"],
  setup(T, {
    emit: A
  }) {
    const {
      pageState: t
    } = E(), {
      getMaterial: i
    } = B(), {
      PLUGIN_NAME: r
    } = R(), D = q(() => {
      var n;
      return (n = T.fixedPanels) == null ? void 0 : n.includes(r.OutlineTree);
    }), {
      useMultiSelect: s,
      registerHotkeyEvent: p,
      removeHotkeyEvent: y
    } = K("engine.canvas.container").api, l = q(() => s().multiSelectedStates.value.map((n) => n.id)), N = ie({
      emitEvent: A
    });
    ve("panelState", N);
    const d = b((n) => {
      const e = b((a) => (a.forEach((u) => {
        u.show = t.nodesStatus[u.id] !== !1, u.showEye = !u.show;
        const k = u.children;
        Array.isArray(k) && e(u.children);
      }), a), {
        metaData: {
          id: "engine.plugins.outlinetree.Main.translateChild"
        },
        ctx: () => ({
          translateChild: e,
          props: T,
          emit: A,
          pageState: t,
          getMaterial: i,
          PLUGIN_NAME: r,
          panelFixed: D,
          useMultiSelect: s,
          registerHotkeyEvent: p,
          removeHotkeyEvent: y,
          selectedIds: l,
          panelState: N,
          filterSchema: d,
          state: g,
          subscribe: f,
          unsubscribe: m,
          eyeOpen: x,
          showNode: C,
          delNode: M,
          handleMouseEnterRow: o,
          disallowDrop: w,
          handleDrop: S,
          handleClickRow: _,
          getIconName: h,
          panelRef: c,
          eventFilter: v,
          PluginPanel: U,
          constants: G,
          useCanvas: E,
          useMaterial: B,
          useLayout: R,
          useMessage: z,
          useHistory: L,
          getMergeMeta: K,
          extend: F,
          DraggableTree: j,
          PAGE_STATUS: O
        })
      });
      return [{
        ...e([F(!0, {}, n)])[0],
        componentName: "body",
        id: "body"
      }];
    }, {
      metaData: {
        id: "engine.plugins.outlinetree.Main.filterSchema"
      },
      ctx: () => ({
        props: T,
        emit: A,
        pageState: t,
        getMaterial: i,
        PLUGIN_NAME: r,
        panelFixed: D,
        useMultiSelect: s,
        registerHotkeyEvent: p,
        removeHotkeyEvent: y,
        selectedIds: l,
        panelState: N,
        filterSchema: d,
        state: g,
        subscribe: f,
        unsubscribe: m,
        eyeOpen: x,
        showNode: C,
        delNode: M,
        handleMouseEnterRow: o,
        disallowDrop: w,
        handleDrop: S,
        handleClickRow: _,
        getIconName: h,
        panelRef: c,
        eventFilter: v,
        PluginPanel: U,
        constants: G,
        useCanvas: E,
        useMaterial: B,
        useLayout: R,
        useMessage: z,
        useHistory: L,
        getMergeMeta: K,
        extend: F,
        DraggableTree: j,
        PAGE_STATUS: O
      })
    }), g = ie({
      pageSchema: [],
      isLock: q(() => ![O.Occupy, O.Guest].includes(R().layoutState.pageStatus.state))
    }), {
      subscribe: f,
      unsubscribe: m
    } = z();
    be(b(b(() => {
      g.pageSchema = d(t.pageSchema), f({
        topic: "schemaChange",
        subscriber: "node-tree",
        callback: ({
          operation: n
        }) => {
          (n == null ? void 0 : n.type) !== "changeProps" && (g.pageSchema = d(t.pageSchema));
        }
      });
    }, {
      metaData: {
        id: "engine.plugins.outlinetree.Main.onActivated[0]"
      },
      ctx: () => ({
        props: T,
        emit: A,
        pageState: t,
        getMaterial: i,
        PLUGIN_NAME: r,
        panelFixed: D,
        useMultiSelect: s,
        registerHotkeyEvent: p,
        removeHotkeyEvent: y,
        selectedIds: l,
        panelState: N,
        filterSchema: d,
        state: g,
        subscribe: f,
        unsubscribe: m,
        eyeOpen: x,
        showNode: C,
        delNode: M,
        handleMouseEnterRow: o,
        disallowDrop: w,
        handleDrop: S,
        handleClickRow: _,
        getIconName: h,
        panelRef: c,
        eventFilter: v,
        PluginPanel: U,
        constants: G,
        useCanvas: E,
        useMaterial: B,
        useLayout: R,
        useMessage: z,
        useHistory: L,
        getMergeMeta: K,
        extend: F,
        DraggableTree: j,
        PAGE_STATUS: O
      })
    }), {
      metaData: {
        id: "engine.plugins.outlinetree.Main.onActivated[0]"
      },
      ctx: () => ({
        props: T,
        emit: A,
        pageState: t,
        getMaterial: i,
        PLUGIN_NAME: r,
        panelFixed: D,
        useMultiSelect: s,
        registerHotkeyEvent: p,
        removeHotkeyEvent: y,
        selectedIds: l,
        panelState: N,
        filterSchema: d,
        state: g,
        subscribe: f,
        unsubscribe: m,
        eyeOpen: x,
        showNode: C,
        delNode: M,
        handleMouseEnterRow: o,
        disallowDrop: w,
        handleDrop: S,
        handleClickRow: _,
        getIconName: h,
        panelRef: c,
        eventFilter: v,
        _callEntry: b,
        _useCompile: W,
        _metaData: Q,
        PluginPanel: U,
        constants: G,
        useCanvas: E,
        useMaterial: B,
        useLayout: R,
        useMessage: z,
        useHistory: L,
        getMergeMeta: K,
        extend: F,
        DraggableTree: j,
        PAGE_STATUS: O
      })
    })), ye(b(b(() => {
      m({
        topic: "schemaChange",
        subscriber: "node-tree"
      });
    }, {
      metaData: {
        id: "engine.plugins.outlinetree.Main.onDeactivated[0]"
      },
      ctx: () => ({
        props: T,
        emit: A,
        pageState: t,
        getMaterial: i,
        PLUGIN_NAME: r,
        panelFixed: D,
        useMultiSelect: s,
        registerHotkeyEvent: p,
        removeHotkeyEvent: y,
        selectedIds: l,
        panelState: N,
        filterSchema: d,
        state: g,
        subscribe: f,
        unsubscribe: m,
        eyeOpen: x,
        showNode: C,
        delNode: M,
        handleMouseEnterRow: o,
        disallowDrop: w,
        handleDrop: S,
        handleClickRow: _,
        getIconName: h,
        panelRef: c,
        eventFilter: v,
        PluginPanel: U,
        constants: G,
        useCanvas: E,
        useMaterial: B,
        useLayout: R,
        useMessage: z,
        useHistory: L,
        getMergeMeta: K,
        extend: F,
        DraggableTree: j,
        PAGE_STATUS: O
      })
    }), {
      metaData: {
        id: "engine.plugins.outlinetree.Main.onDeactivated[0]"
      },
      ctx: () => ({
        props: T,
        emit: A,
        pageState: t,
        getMaterial: i,
        PLUGIN_NAME: r,
        panelFixed: D,
        useMultiSelect: s,
        registerHotkeyEvent: p,
        removeHotkeyEvent: y,
        selectedIds: l,
        panelState: N,
        filterSchema: d,
        state: g,
        subscribe: f,
        unsubscribe: m,
        eyeOpen: x,
        showNode: C,
        delNode: M,
        handleMouseEnterRow: o,
        disallowDrop: w,
        handleDrop: S,
        handleClickRow: _,
        getIconName: h,
        panelRef: c,
        eventFilter: v,
        _callEntry: b,
        _useCompile: W,
        _metaData: Q,
        PluginPanel: U,
        constants: G,
        useCanvas: E,
        useMaterial: B,
        useLayout: R,
        useMessage: z,
        useHistory: L,
        getMergeMeta: K,
        extend: F,
        DraggableTree: j,
        PAGE_STATUS: O
      })
    })), xe(() => t.currentSchema, () => {
      const {
        getSchema: n
      } = E();
      g.pageSchema = d(n());
    });
    const x = b((n) => t.nodesStatus[n] !== !1, {
      metaData: {
        id: "engine.plugins.outlinetree.Main.eyeOpen"
      },
      ctx: () => ({
        props: T,
        emit: A,
        pageState: t,
        getMaterial: i,
        PLUGIN_NAME: r,
        panelFixed: D,
        useMultiSelect: s,
        registerHotkeyEvent: p,
        removeHotkeyEvent: y,
        selectedIds: l,
        panelState: N,
        filterSchema: d,
        state: g,
        subscribe: f,
        unsubscribe: m,
        eyeOpen: x,
        showNode: C,
        delNode: M,
        handleMouseEnterRow: o,
        disallowDrop: w,
        handleDrop: S,
        handleClickRow: _,
        getIconName: h,
        panelRef: c,
        eventFilter: v,
        PluginPanel: U,
        constants: G,
        useCanvas: E,
        useMaterial: B,
        useLayout: R,
        useMessage: z,
        useHistory: L,
        getMergeMeta: K,
        extend: F,
        DraggableTree: j,
        PAGE_STATUS: O
      })
    }), C = b((n) => {
      n.show = !n.show, t.nodesStatus[n.id] = n.show;
      const {
        getRenderer: e,
        clearSelect: a
      } = E().canvasApi.value;
      e().setCondition(n.id, n.show), a();
    }, {
      metaData: {
        id: "engine.plugins.outlinetree.Main.showNode"
      },
      ctx: () => ({
        props: T,
        emit: A,
        pageState: t,
        getMaterial: i,
        PLUGIN_NAME: r,
        panelFixed: D,
        useMultiSelect: s,
        registerHotkeyEvent: p,
        removeHotkeyEvent: y,
        selectedIds: l,
        panelState: N,
        filterSchema: d,
        state: g,
        subscribe: f,
        unsubscribe: m,
        eyeOpen: x,
        showNode: C,
        delNode: M,
        handleMouseEnterRow: o,
        disallowDrop: w,
        handleDrop: S,
        handleClickRow: _,
        getIconName: h,
        panelRef: c,
        eventFilter: v,
        PluginPanel: U,
        constants: G,
        useCanvas: E,
        useMaterial: B,
        useLayout: R,
        useMessage: z,
        useHistory: L,
        getMergeMeta: K,
        extend: F,
        DraggableTree: j,
        PAGE_STATUS: O
      })
    }), M = b((n) => {
      const {
        clearSelect: e
      } = E().canvasApi.value;
      E().operateNode({
        type: "delete",
        id: n.id
      }), e(), L().addHistory();
    }, {
      metaData: {
        id: "engine.plugins.outlinetree.Main.delNode"
      },
      ctx: () => ({
        props: T,
        emit: A,
        pageState: t,
        getMaterial: i,
        PLUGIN_NAME: r,
        panelFixed: D,
        useMultiSelect: s,
        registerHotkeyEvent: p,
        removeHotkeyEvent: y,
        selectedIds: l,
        panelState: N,
        filterSchema: d,
        state: g,
        subscribe: f,
        unsubscribe: m,
        eyeOpen: x,
        showNode: C,
        delNode: M,
        handleMouseEnterRow: o,
        disallowDrop: w,
        handleDrop: S,
        handleClickRow: _,
        getIconName: h,
        panelRef: c,
        eventFilter: v,
        PluginPanel: U,
        constants: G,
        useCanvas: E,
        useMaterial: B,
        useLayout: R,
        useMessage: z,
        useHistory: L,
        getMergeMeta: K,
        extend: F,
        DraggableTree: j,
        PAGE_STATUS: O
      })
    }), o = b((n) => {
      const {
        hoverNode: e
      } = E().canvasApi.value;
      e(n.id);
    }, {
      metaData: {
        id: "engine.plugins.outlinetree.Main.handleMouseEnterRow"
      },
      ctx: () => ({
        props: T,
        emit: A,
        pageState: t,
        getMaterial: i,
        PLUGIN_NAME: r,
        panelFixed: D,
        useMultiSelect: s,
        registerHotkeyEvent: p,
        removeHotkeyEvent: y,
        selectedIds: l,
        panelState: N,
        filterSchema: d,
        state: g,
        subscribe: f,
        unsubscribe: m,
        eyeOpen: x,
        showNode: C,
        delNode: M,
        handleMouseEnterRow: o,
        disallowDrop: w,
        handleDrop: S,
        handleClickRow: _,
        getIconName: h,
        panelRef: c,
        eventFilter: v,
        PluginPanel: U,
        constants: G,
        useCanvas: E,
        useMaterial: B,
        useLayout: R,
        useMessage: z,
        useHistory: L,
        getMergeMeta: K,
        extend: F,
        DraggableTree: j,
        PAGE_STATUS: O
      })
    }), w = b(({
      dragged: n,
      target: e,
      position: a
    }) => {
      if (n.id === "body")
        return !0;
      const u = a === "center" ? e : e.parent;
      if (u.id === "body")
        return !1;
      const {
        getConfigure: k,
        allowInsert: H
      } = E().canvasApi.value;
      return !H(k(u.rawData.componentName), n.rawData);
    }, {
      metaData: {
        id: "engine.plugins.outlinetree.Main.disallowDrop"
      },
      ctx: () => ({
        props: T,
        emit: A,
        pageState: t,
        getMaterial: i,
        PLUGIN_NAME: r,
        panelFixed: D,
        useMultiSelect: s,
        registerHotkeyEvent: p,
        removeHotkeyEvent: y,
        selectedIds: l,
        panelState: N,
        filterSchema: d,
        state: g,
        subscribe: f,
        unsubscribe: m,
        eyeOpen: x,
        showNode: C,
        delNode: M,
        handleMouseEnterRow: o,
        disallowDrop: w,
        handleDrop: S,
        handleClickRow: _,
        getIconName: h,
        panelRef: c,
        eventFilter: v,
        PluginPanel: U,
        constants: G,
        useCanvas: E,
        useMaterial: B,
        useLayout: R,
        useMessage: z,
        useHistory: L,
        getMergeMeta: K,
        extend: F,
        DraggableTree: j,
        PAGE_STATUS: O
      })
    }), S = b(({
      dragged: n,
      target: e,
      position: a
    }) => {
      if (n.id === e.id || a === "center" && e.rawData.children.some((Y) => Y.id === n.id))
        return;
      if (a !== "center") {
        const Y = e.parent.rawData.children, V = Y.findIndex((X) => X.id === e.id), I = Y[a === "top" ? V - 1 : V + 1];
        if (n.id === (I == null ? void 0 : I.id))
          return;
      }
      const {
        insertNode: u,
        removeNode: k,
        selectNode: H
      } = E().canvasApi.value;
      k(n.id), u({
        data: n.rawData,
        node: e.rawData,
        parent: e.parent.rawData
      }, a === "center" ? "in" : a), Ce(() => {
        H(n.id, "clickTree");
      });
    }, {
      metaData: {
        id: "engine.plugins.outlinetree.Main.handleDrop"
      },
      ctx: () => ({
        props: T,
        emit: A,
        pageState: t,
        getMaterial: i,
        PLUGIN_NAME: r,
        panelFixed: D,
        useMultiSelect: s,
        registerHotkeyEvent: p,
        removeHotkeyEvent: y,
        selectedIds: l,
        panelState: N,
        filterSchema: d,
        state: g,
        subscribe: f,
        unsubscribe: m,
        eyeOpen: x,
        showNode: C,
        delNode: M,
        handleMouseEnterRow: o,
        disallowDrop: w,
        handleDrop: S,
        handleClickRow: _,
        getIconName: h,
        panelRef: c,
        eventFilter: v,
        PluginPanel: U,
        constants: G,
        useCanvas: E,
        useMaterial: B,
        useLayout: R,
        useMessage: z,
        useHistory: L,
        getMergeMeta: K,
        extend: F,
        DraggableTree: j,
        PAGE_STATUS: O
      })
    }), _ = b((n, e) => {
      const a = n.ctrlKey || n.metaKey, {
        selectNode: u
      } = E().canvasApi.value;
      u(e.id, "clickTree", a);
    }, {
      metaData: {
        id: "engine.plugins.outlinetree.Main.handleClickRow"
      },
      ctx: () => ({
        props: T,
        emit: A,
        pageState: t,
        getMaterial: i,
        PLUGIN_NAME: r,
        panelFixed: D,
        useMultiSelect: s,
        registerHotkeyEvent: p,
        removeHotkeyEvent: y,
        selectedIds: l,
        panelState: N,
        filterSchema: d,
        state: g,
        subscribe: f,
        unsubscribe: m,
        eyeOpen: x,
        showNode: C,
        delNode: M,
        handleMouseEnterRow: o,
        disallowDrop: w,
        handleDrop: S,
        handleClickRow: _,
        getIconName: h,
        panelRef: c,
        eventFilter: v,
        PluginPanel: U,
        constants: G,
        useCanvas: E,
        useMaterial: B,
        useLayout: R,
        useMessage: z,
        useHistory: L,
        getMergeMeta: K,
        extend: F,
        DraggableTree: j,
        PAGE_STATUS: O
      })
    }), h = b((n) => (i(n.rawData.componentName).icon || "plugin-icon-page").toLowerCase(), {
      metaData: {
        id: "engine.plugins.outlinetree.Main.getIconName"
      },
      ctx: () => ({
        props: T,
        emit: A,
        pageState: t,
        getMaterial: i,
        PLUGIN_NAME: r,
        panelFixed: D,
        useMultiSelect: s,
        registerHotkeyEvent: p,
        removeHotkeyEvent: y,
        selectedIds: l,
        panelState: N,
        filterSchema: d,
        state: g,
        subscribe: f,
        unsubscribe: m,
        eyeOpen: x,
        showNode: C,
        delNode: M,
        handleMouseEnterRow: o,
        disallowDrop: w,
        handleDrop: S,
        handleClickRow: _,
        getIconName: h,
        panelRef: c,
        eventFilter: v,
        PluginPanel: U,
        constants: G,
        useCanvas: E,
        useMaterial: B,
        useLayout: R,
        useMessage: z,
        useHistory: L,
        getMergeMeta: K,
        extend: F,
        DraggableTree: j,
        PAGE_STATUS: O
      })
    }), c = re(null), v = b(() => c.value.$el.contains(document.activeElement), {
      metaData: {
        id: "engine.plugins.outlinetree.Main.eventFilter"
      },
      ctx: () => ({
        props: T,
        emit: A,
        pageState: t,
        getMaterial: i,
        PLUGIN_NAME: r,
        panelFixed: D,
        useMultiSelect: s,
        registerHotkeyEvent: p,
        removeHotkeyEvent: y,
        selectedIds: l,
        panelState: N,
        filterSchema: d,
        state: g,
        subscribe: f,
        unsubscribe: m,
        eyeOpen: x,
        showNode: C,
        delNode: M,
        handleMouseEnterRow: o,
        disallowDrop: w,
        handleDrop: S,
        handleClickRow: _,
        getIconName: h,
        panelRef: c,
        eventFilter: v,
        PluginPanel: U,
        constants: G,
        useCanvas: E,
        useMaterial: B,
        useLayout: R,
        useMessage: z,
        useHistory: L,
        getMergeMeta: K,
        extend: F,
        DraggableTree: j,
        PAGE_STATUS: O
      })
    });
    return Me(b(b(() => {
      c.value && p(document, {
        eventFilter: v
      });
    }, {
      metaData: {
        id: "engine.plugins.outlinetree.Main.onMounted[0]"
      },
      ctx: () => ({
        props: T,
        emit: A,
        pageState: t,
        getMaterial: i,
        PLUGIN_NAME: r,
        panelFixed: D,
        useMultiSelect: s,
        registerHotkeyEvent: p,
        removeHotkeyEvent: y,
        selectedIds: l,
        panelState: N,
        filterSchema: d,
        state: g,
        subscribe: f,
        unsubscribe: m,
        eyeOpen: x,
        showNode: C,
        delNode: M,
        handleMouseEnterRow: o,
        disallowDrop: w,
        handleDrop: S,
        handleClickRow: _,
        getIconName: h,
        panelRef: c,
        eventFilter: v,
        PluginPanel: U,
        constants: G,
        useCanvas: E,
        useMaterial: B,
        useLayout: R,
        useMessage: z,
        useHistory: L,
        getMergeMeta: K,
        extend: F,
        DraggableTree: j,
        PAGE_STATUS: O
      })
    }), {
      metaData: {
        id: "engine.plugins.outlinetree.Main.onMounted[0]"
      },
      ctx: () => ({
        props: T,
        emit: A,
        pageState: t,
        getMaterial: i,
        PLUGIN_NAME: r,
        panelFixed: D,
        useMultiSelect: s,
        registerHotkeyEvent: p,
        removeHotkeyEvent: y,
        selectedIds: l,
        panelState: N,
        filterSchema: d,
        state: g,
        subscribe: f,
        unsubscribe: m,
        eyeOpen: x,
        showNode: C,
        delNode: M,
        handleMouseEnterRow: o,
        disallowDrop: w,
        handleDrop: S,
        handleClickRow: _,
        getIconName: h,
        panelRef: c,
        eventFilter: v,
        _callEntry: b,
        _useCompile: W,
        _metaData: Q,
        PluginPanel: U,
        constants: G,
        useCanvas: E,
        useMaterial: B,
        useLayout: R,
        useMessage: z,
        useHistory: L,
        getMergeMeta: K,
        extend: F,
        DraggableTree: j,
        PAGE_STATUS: O
      })
    })), Se(b(b(() => {
      c.value && y(document);
    }, {
      metaData: {
        id: "engine.plugins.outlinetree.Main.onBeforeUnmount[0]"
      },
      ctx: () => ({
        props: T,
        emit: A,
        pageState: t,
        getMaterial: i,
        PLUGIN_NAME: r,
        panelFixed: D,
        useMultiSelect: s,
        registerHotkeyEvent: p,
        removeHotkeyEvent: y,
        selectedIds: l,
        panelState: N,
        filterSchema: d,
        state: g,
        subscribe: f,
        unsubscribe: m,
        eyeOpen: x,
        showNode: C,
        delNode: M,
        handleMouseEnterRow: o,
        disallowDrop: w,
        handleDrop: S,
        handleClickRow: _,
        getIconName: h,
        panelRef: c,
        eventFilter: v,
        PluginPanel: U,
        constants: G,
        useCanvas: E,
        useMaterial: B,
        useLayout: R,
        useMessage: z,
        useHistory: L,
        getMergeMeta: K,
        extend: F,
        DraggableTree: j,
        PAGE_STATUS: O
      })
    }), {
      metaData: {
        id: "engine.plugins.outlinetree.Main.onBeforeUnmount[0]"
      },
      ctx: () => ({
        props: T,
        emit: A,
        pageState: t,
        getMaterial: i,
        PLUGIN_NAME: r,
        panelFixed: D,
        useMultiSelect: s,
        registerHotkeyEvent: p,
        removeHotkeyEvent: y,
        selectedIds: l,
        panelState: N,
        filterSchema: d,
        state: g,
        subscribe: f,
        unsubscribe: m,
        eyeOpen: x,
        showNode: C,
        delNode: M,
        handleMouseEnterRow: o,
        disallowDrop: w,
        handleDrop: S,
        handleClickRow: _,
        getIconName: h,
        panelRef: c,
        eventFilter: v,
        _callEntry: b,
        _useCompile: W,
        _metaData: Q,
        PluginPanel: U,
        constants: G,
        useCanvas: E,
        useMaterial: B,
        useLayout: R,
        useMessage: z,
        useHistory: L,
        getMergeMeta: K,
        extend: F,
        DraggableTree: j,
        PAGE_STATUS: O
      })
    })), {
      panelFixed: D,
      selectedIds: l,
      panelRef: c,
      eyeOpen: x,
      delNode: M,
      showNode: C,
      state: g,
      PLUGIN_NAME: r,
      pageState: t,
      getIconName: h,
      handleClickRow: _,
      handleMouseEnterRow: o,
      disallowDrop: w,
      handleDrop: S
    };
  }
}, Ee = { class: "row-content" };
function Ae(T, A, t, i, r, D) {
  const s = Z("svg-icon"), p = Z("draggable-tree"), y = Z("plugin-panel");
  return $(), oe(y, {
    tabindex: "0",
    title: "大纲树",
    ref: "panelRef",
    class: "outlinebox plugin-tree",
    "fixed-name": i.PLUGIN_NAME.OutlineTree,
    fixedPanels: t.fixedPanels,
    onClose: A[0] || (A[0] = (l) => T.$emit("close"))
  }, {
    content: le(() => [
      ae(p, {
        "label-key": "componentName",
        data: i.state.pageSchema,
        draggable: !0,
        actives: i.selectedIds,
        "disallow-drop": i.disallowDrop,
        class: "outline-tree",
        onClick: i.handleClickRow,
        onMouseenter: i.handleMouseEnterRow,
        onDrop: i.handleDrop
      }, {
        content: le((l) => [
          te("div", Ee, [
            i.getIconName(l) ? ($(), oe(s, {
              key: 0,
              name: i.getIconName(l)
            }, null, 8, ["name"])) : ne("", !0),
            te("span", {
              class: ee(["row-label", { "node-isblock": l.rawData.componentType === "Block" }])
            }, _e(l.label), 3),
            l.id !== "body" ? ($(), J(se, { key: 1 }, [
              ae(s, {
                name: i.eyeOpen(l.id) ? "eye" : "eye-invisible",
                onMouseup: (N) => i.showNode(l.rawData)
              }, null, 8, ["name", "onMouseup"]),
              ae(s, {
                name: "delete",
                onMouseup: (N) => i.delNode(l.rawData)
              }, null, 8, ["onMouseup"])
            ], 64)) : ne("", !0)
          ])
        ]),
        _: 1
      }, 8, ["data", "actives", "disallow-drop", "onClick", "onMouseenter", "onDrop"])
    ]),
    _: 1
  }, 8, ["fixed-name", "fixedPanels"]);
}
const Ie = /* @__PURE__ */ ce(Te, [["render", Ae], ["__scopeId", "data-v-356e534e"]]), ze = {
  ...Q,
  entry: Ie
};
export {
  ze as default
};
//# sourceMappingURL=index.js.map
